Subject: Re: bug#29525: Please don't default to "--unique" mode for Okular

From: Mosè Giordano <[email-masked]>
Date: Sun, 3 Dec 2017 02:13:22 +0100

2017-12-02 19:52 GMT+01:00 Reuben Thomas <[email-masked]>:
> Thanks very much to both of you for your feedback.
>
> On 1 December 2017 at 21:49, Arash Esbati <[email-masked]> wrote:
>>
>>
>> it is also the default for Yap, dviout, SumatraPDF.  And this is the
>> problem with defaults: Never 100% satisfied customers.
>
>
> The problem in this case is not the default per se (though it is hard to
> work out how to configure it: the customize interface for this setting is
> overcomplicated), it is that the default is different for different
> previewers. The default should (as far as possible) be the same, so that
> changing viewers does not change the behaviour.
>
> Mosè said: "Without this option you'll need to close Okular to view again
> (C-c C-v) the document without spawing several instances of the viewer for
> the same document."
>
> This is not exactly true: once Okular (or Evince) has been spawned, there is
> no need to run the View command again: both viewers auto-reload.

You're saying that it isn't necessary, this doesn't make my previous
statement false --- I mentioned C-c C-v for a reason.  Switching to
the viewer with C-c C-v is what I do, rather than using the window
manager to get to the viewer: I have always several programs open at
the same time, Emacs' and Okular's windows are rarely the closest
ones.  Also, C-c C-a opens the viewer with TeX-view at the end of
compilation, but this is optional.

The more I think about this, the more I'm convinced that the issue you
raised is sensible but the best solution would be to fix first
upstream in Okular.  It'd be a good improvement.  After that, I'll be
more than happy to remove the --unique option.

If you are working with many documents at the same time (say 3-4 or
even more) switching between Emacs and the wanted document can be
really annoying, using C-c C-v brings to focus the right instance of
the viewer.  This is what Evince does and is much more convenient.

> For the Customize interface, I'm not sure what to suggest. The current
> interface is far too complicated, but if it were made simpler (e.g. to have
> a "single instance" toggle) then it would not be so general.

This is an interesting suggestion but probably not so easy to adopt.

> Arash, you mention editing .emacs; this is a shame.

Please, there is no need to put shame on anyone.

> It's not the 1990s any
> more: I don't even have a .emacs file, I have .emacs.d/init.el

I honestly don't get what you mean here.

> but more to
> the point, the default should be to say "customize foo to bar". To advise
> editing .emacs is either a) confusing, b) an admission that Customization
> isn't manageable, or c) both.

Well, he did suggest you to customize `TeX-view-program-list', *and*
provided you, as a possibility, with two lines of code to add to your
init file to accomplish the same task.  It's up to you to decide
what's best for you.  I really don't see what's the problem here.

Bye,
Mosè